#ifndef FMMATH_H
#define FMMATH_H

#ifdef BCB
#define max(a,b)	(a) > (b)? (a) : (b)
#define min(a,b)	(a) < (b)? (a) : (b)
#include <math.h>	// sqrt
#endif

#ifndef M_PI
	#define M_PI       3.14159265358979323846
#endif

//---------------------------------------------------------------------------

static double fm_fr2x (double d, double m)
{
	return sin(d) * m;
}

static double fm_fr2y (double d, double m)
{
	return cos(d) * m;
}

static double fm_fc2m (double x, double y)
{
	return _hypot(x, y);
}

static double fm_fc2d (double x, double y)
{
	double m = _hypot(x, y);
	if (m > 0.) {
		double d = acos(y / m);
		return (x < 0.? (M_PI * 2.) - d : d);
	}
	return 0.;
}

//---------------------------------------------------------------------------
			  /*
struct Vector {
	double x, y, z;
};

__inline static double vectorDotProduct (struct Vector a, struct Vector b) {
	return ((a.x * b.x) + (a.y * b.y) + (a.z * b.z));
}

__inline static double vectorLength (struct Vector a) {
	return sqrt((a.x * a.x) + (a.y * a.y) + (a.z * a.z));
}

__inline static double vectorAngleDiff (struct Vector a, struct Vector b) {
	double dp = vectorDotProduct(a, b);
	double la = vectorLength(a);
	double lb = vectorLength(b);
	double d = dp / (la * lb);

	if (d >= 1.) {
		return 0.;
	} else if (d <= -1.) {
		return M_PI;
	}

	return acos(d);
}

__inline static struct Vector vectorRotateY(struct Vector v, double r) {
	double m = fm_fc2m(v.x, v.z);
	double d = fm_fc2d(v.x, v.z);
	d += r;
	v.x = fm_fr2x(d, m);
	v.z = fm_fr2y(d, m);
	return v;
}

__inline static struct Vector vectorRotateX(struct Vector v, double r) {
	double m = fm_fc2m(v.y, v.z);
	double d = fm_fc2d(v.y, v.z);
	d += r;
	v.y = fm_fr2x(d, m);
	v.z = fm_fr2y(d, m);
	return v;
}
             */
#endif
// FMMATH_H
